import tomllib
from datetime import date, datetime, timedelta, timezone
import json
from threading import Timer
from sense_hat import SenseHat
from signal import pause
from urllib import request, parse

from .tempo import TempoAPI
from .logger import SenseLogger
from .info import InfoPanel

with open("config.toml", "rb") as config_file:
    config = tomllib.load(config_file)

sense = SenseHat()
tempo_api = TempoAPI(config.get("rte_api_key"))


sense_logger = SenseLogger(sense, "dbname=tsdb user=edpibu host=/run/postgresql")
info_panel = InfoPanel(sense, tempo_api)

sense.show_message(">")
