from itertools import chain


def digit_to_pixels(n, color=[255, 255, 255], bg_color=[0, 0, 0]):
    X = color
    O = bg_color
    match n:
        case "0":
            return [
                [O, O, O, O],
                [O, X, X, O],
                [X, O, O, X],
                [X, O, O, X],
                [X, O, O, X],
                [X, O, O, X],
                [O, X, X, O],
                [O, O, O, O],
            ]
        case "1":
            return [
                [O, O, O, O],
                [O, O, O, X],
                [O, O, X, X],
                [O, X, O, X],
                [O, O, O, X],
                [O, O, O, X],
                [O, O, O, X],
                [O, O, O, O],
            ]
        case "2":
            return [
                [O, O, O, O],
                [O, X, X, O],
                [X, O, O, X],
                [O, O, O, X],
                [O, O, X, O],
                [O, X, O, O],
                [X, X, X, X],
                [O, O, O, O],
            ]
        case "3":
            return [
                [O, O, O, O],
                [X, X, X, X],
                [O, O, O, X],
                [O, O, X, O],
                [O, O, O, X],
                [X, O, O, X],
                [O, X, X, O],
                [O, O, O, O],
            ]
        case "4":
            return [
                [O, O, O, O],
                [O, O, O, X],
                [O, O, X, X],
                [O, X, O, X],
                [X, O, X, X],
                [X, X, X, X],
                [O, O, O, X],
                [O, O, O, O],
            ]
        case "5":
            return [
                [O, O, O, O],
                [X, X, X, X],
                [X, O, O, O],
                [X, X, X, O],
                [O, O, O, X],
                [X, O, O, X],
                [O, X, X, O],
                [O, O, O, O],
            ]
        case "6":
            return [
                [O, O, O, O],
                [O, X, X, X],
                [X, O, O, O],
                [X, X, X, O],
                [X, O, O, X],
                [X, O, O, X],
                [O, X, X, O],
                [O, O, O, O],
            ]
        case "7":
            return [
                [O, O, O, O],
                [X, X, X, X],
                [O, O, O, X],
                [O, O, X, O],
                [O, X, O, O],
                [X, O, O, O],
                [X, O, O, O],
                [O, O, O, O],
            ]
        case "8":
            return [
                [O, O, O, O],
                [O, X, X, O],
                [X, O, O, X],
                [O, X, X, O],
                [X, O, O, X],
                [X, O, O, X],
                [O, X, X, O],
                [O, O, O, O],
            ]
        case "9":
            return [
                [O, O, O, O],
                [O, X, X, O],
                [X, O, O, X],
                [X, O, O, X],
                [O, X, X, X],
                [O, O, O, X],
                [O, X, X, O],
                [O, O, O, O],
            ]
        case _:
            return 8 * [4 * [O]]


def num_to_pixels(n, color=[255, 255, 255], bg_color=[0, 0, 0]):
    digits = f"{n:02.0f}"
    if len(digits) > 2:
        digits = "XX"

    return list(
        chain.from_iterable(
            chain.from_iterable(
                zip(*[digit_to_pixels(i, color, bg_color) for i in digits])
            )
        )
    )
